/*****************************************************************************
* Filename:          C:\Users\Magician\Desktop\bsb_project/drivers/ip_testing_mod_v1_00_a/src/ip_testing_mod.c
* Version:           1.00.a
* Description:       ip_testing_mod Driver Source File
* Date:              Fri Jun 04 18:30:14 2010 (by Create and Import Peripheral Wizard)
*****************************************************************************/


/***************************** Include Files *******************************/

#include "ip_testing_mod.h"

/************************** Function Definitions ***************************/

/**
 *
 * Enable all possible interrupts from IP_TESTING_MOD device.
 *
 * @param   baseaddr_p is the base address of the IP_TESTING_MOD device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void IP_TESTING_MOD_EnableInterrupt(void * baseaddr_p)
{
  Xuint32 baseaddr;
  baseaddr = (Xuint32) baseaddr_p;

  /*
   * Enable all interrupt source from user logic.
   */
  IP_TESTING_MOD_mWriteReg(baseaddr, IP_TESTING_MOD_INTR_IPIER_OFFSET, 0x00000001);

  /*
   * Set global interrupt enable.
   */
  IP_TESTING_MOD_mWriteReg(baseaddr, IP_TESTING_MOD_INTR_DGIER_OFFSET, INTR_GIE_MASK);
}

/**
 *
 * Example interrupt controller handler for IP_TESTING_MOD device.
 * This is to show example of how to toggle write back ISR to clear interrupts.
 *
 * @param   baseaddr_p is the base address of the IP_TESTING_MOD device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void IP_TESTING_MOD_Intr_DefaultHandler(void * baseaddr_p)
{
  Xuint32 baseaddr;
  Xuint32 IntrStatus;
Xuint32 IpStatus;
  baseaddr = (Xuint32) baseaddr_p;

  {
    xil_printf("User logic interrupt! \n\r");
    IpStatus = IP_TESTING_MOD_mReadReg(baseaddr, IP_TESTING_MOD_INTR_IPISR_OFFSET);
    IP_TESTING_MOD_mWriteReg(baseaddr, IP_TESTING_MOD_INTR_IPISR_OFFSET, IpStatus);
  }

}

