/*****************************************************************************
* Filename:          C:\Users\Magician\Desktop\bsb_project/drivers/ip_testing_mod_v1_00_a/src/ip_testing_mod.h
* Version:           1.00.a
* Description:       ip_testing_mod Driver Header File
* Date:              Fri Jun 04 18:30:14 2010 (by Create and Import Peripheral Wizard)
*****************************************************************************/

#ifndef IP_TESTING_MOD_H
#define IP_TESTING_MOD_H

/***************************** Include Files *******************************/

#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"

/************************** Constant Definitions ***************************/


/**
 * User Logic Slave Space Offsets
 * -- SLV_REG0 : user logic slave module register 0
 * -- SLV_REG1 : user logic slave module register 1
 */
#define IP_TESTING_MOD_USER_SLV_SPACE_OFFSET (0x00000000)
#define IP_TESTING_MOD_SLV_REG0_OFFSET (IP_TESTING_MOD_USER_SLV_SPACE_OFFSET + 0x00000000)
#define IP_TESTING_MOD_SLV_REG1_OFFSET (IP_TESTING_MOD_USER_SLV_SPACE_OFFSET + 0x00000004)

/**
 * Interrupt Controller Space Offsets
 * -- INTR_DGIER : device (peripheral) global interrupt enable register
 * -- INTR_ISR   : ip (user logic) interrupt status register
 * -- INTR_IER   : ip (user logic) interrupt enable register
 */
#define IP_TESTING_MOD_INTR_CNTRL_SPACE_OFFSET (0x00000100)
#define IP_TESTING_MOD_INTR_DGIER_OFFSET (IP_TESTING_MOD_INTR_CNTRL_SPACE_OFFSET + 0x0000001C)
#define IP_TESTING_MOD_INTR_IPISR_OFFSET (IP_TESTING_MOD_INTR_CNTRL_SPACE_OFFSET + 0x00000020)
#define IP_TESTING_MOD_INTR_IPIER_OFFSET (IP_TESTING_MOD_INTR_CNTRL_SPACE_OFFSET + 0x00000028)

/**
 * Interrupt Controller Masks
 * -- INTR_TERR_MASK : transaction error
 * -- INTR_DPTO_MASK : data phase time-out
 * -- INTR_IPIR_MASK : ip interrupt requeset
 * -- INTR_RFDL_MASK : read packet fifo deadlock interrupt request
 * -- INTR_WFDL_MASK : write packet fifo deadlock interrupt request
 * -- INTR_IID_MASK  : interrupt id
 * -- INTR_GIE_MASK  : global interrupt enable
 * -- INTR_NOPEND    : the DIPR has no pending interrupts
 */
#define INTR_TERR_MASK (0x00000001UL)
#define INTR_DPTO_MASK (0x00000002UL)
#define INTR_IPIR_MASK (0x00000004UL)
#define INTR_RFDL_MASK (0x00000020UL)
#define INTR_WFDL_MASK (0x00000040UL)
#define INTR_IID_MASK (0x000000FFUL)
#define INTR_GIE_MASK (0x80000000UL)
#define INTR_NOPEND (0x80)

/**************************** Type Definitions *****************************/


/***************** Macros (Inline Functions) Definitions *******************/

/**
 *
 * Write a value to a IP_TESTING_MOD register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the IP_TESTING_MOD device.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void IP_TESTING_MOD_mWriteReg(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Data)
 *
 */
#define IP_TESTING_MOD_mWriteReg(BaseAddress, RegOffset, Data) \
 	xil_io_out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

/**
 *
 * Read a value from a IP_TESTING_MOD register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the IP_TESTING_MOD device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note
 * C-style signature:
 * 	Xuint32 IP_TESTING_MOD_mReadReg(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define IP_TESTING_MOD_mReadReg(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (RegOffset))


/**
 *
 * Write/Read 32 bit value to/from IP_TESTING_MOD user logic slave registers.
 *
 * @param   BaseAddress is the base address of the IP_TESTING_MOD device.
 * @param   RegOffset is the offset from the slave register to write to or read from.
 * @param   Value is the data written to the register.
 *
 * @return  Data is the data from the user logic slave register.
 *
 * @note
 * C-style signature:
 * 	void IP_TESTING_MOD_mWriteSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Value)
 * 	Xuint32 IP_TESTING_MOD_mReadSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define IP_TESTING_MOD_mWriteSlaveReg0(BaseAddress, RegOffset, Value) \
 	xil_io_out32((BaseAddress) + (IP_TESTING_MOD_SLV_REG0_OFFSET) + (RegOffset), (Xuint32)(Value))
#define IP_TESTING_MOD_mWriteSlaveReg1(BaseAddress, RegOffset, Value) \
 	xil_io_out32((BaseAddress) + (IP_TESTING_MOD_SLV_REG1_OFFSET) + (RegOffset), (Xuint32)(Value))

#define IP_TESTING_MOD_mReadSlaveReg0(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (IP_TESTING_MOD_SLV_REG0_OFFSET) + (RegOffset))
#define IP_TESTING_MOD_mReadSlaveReg1(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (IP_TESTING_MOD_SLV_REG1_OFFSET) + (RegOffset))

/************************** Function Prototypes ****************************/


/**
 *
 * Enable all possible interrupts from IP_TESTING_MOD device.
 *
 * @param   baseaddr_p is the base address of the IP_TESTING_MOD device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void IP_TESTING_MOD_EnableInterrupt(void * baseaddr_p);

/**
 *
 * Example interrupt controller handler.
 *
 * @param   baseaddr_p is the base address of the IP_TESTING_MOD device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void IP_TESTING_MOD_Intr_DefaultHandler(void * baseaddr_p);

/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the IP_TESTING_MOD instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */
XStatus IP_TESTING_MOD_SelfTest(void * baseaddr_p);

#endif /** IP_TESTING_MOD_H */
