/*****************************************************************************
* Filename:          C:\Users\Magician\Desktop\BSB\bsb_project/drivers/my_custom_ip_register_v9_00_a/src/my_custom_ip_register.c
* Version:           9.00.a
* Description:       my_custom_ip_register Driver Source File
* Date:              Sat May 29 12:48:06 2010 (by Create and Import Peripheral Wizard)
*****************************************************************************/


/***************************** Include Files *******************************/

#include "my_custom_ip_register.h"


/************************** Function Definitions ***************************/

/**
 *
 * Enable all possible interrupts from MY_CUSTOM_IP_REGISTER device.
 *
 * @param   baseaddr_p is the base address of the MY_CUSTOM_IP_REGISTER device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void MY_CUSTOM_IP_REGISTER_EnableInterrupt(void * baseaddr_p)
{
  Xuint32 baseaddr;
  baseaddr = (Xuint32) baseaddr_p;

  /*
   * Enable all interrupt source from user logic.
   */
  MY_CUSTOM_IP_REGISTER_mWriteReg(baseaddr, MY_CUSTOM_IP_REGISTER_INTR_IPIER_OFFSET, 0x00000001);

  /*
   * Enable all possible interrupt sources from device.
   */
  MY_CUSTOM_IP_REGISTER_mWriteReg(baseaddr, MY_CUSTOM_IP_REGISTER_INTR_DIER_OFFSET,
    INTR_TERR_MASK
    | INTR_DPTO_MASK
    | INTR_IPIR_MASK
    );

  /*
   * Set global interrupt enable.
   */
  MY_CUSTOM_IP_REGISTER_mWriteReg(baseaddr, MY_CUSTOM_IP_REGISTER_INTR_DGIER_OFFSET, INTR_GIE_MASK);
}

/**
 *
 * Example interrupt controller handler for MY_CUSTOM_IP_REGISTER device.
 * This is to show example of how to toggle write back ISR to clear interrupts.
 *
 * @param   baseaddr_p is the base address of the MY_CUSTOM_IP_REGISTER device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void MY_CUSTOM_IP_REGISTER_Intr_DefaultHandler(void * baseaddr_p)
{
  Xuint32 baseaddr;
  Xuint32 IntrStatus;
Xuint32 IpStatus;
  baseaddr = (Xuint32) baseaddr_p;

  /*
   * Get status from Device Interrupt Status Register.
   */
  IntrStatus = MY_CUSTOM_IP_REGISTER_mReadReg(baseaddr, MY_CUSTOM_IP_REGISTER_INTR_DISR_OFFSET);

  xil_printf("Device Interrupt! DISR value : 0x%08x \n\r", IntrStatus);

  /*
   * Verify the source of the interrupt is the user logic and clear the interrupt
   * source by toggle write baca to the IP ISR register.
   */
  if ( (IntrStatus & INTR_IPIR_MASK) == INTR_IPIR_MASK )
  {
    xil_printf("User logic interrupt! \n\r");
    IpStatus = MY_CUSTOM_IP_REGISTER_mReadReg(baseaddr, MY_CUSTOM_IP_REGISTER_INTR_IPISR_OFFSET);
    MY_CUSTOM_IP_REGISTER_mWriteReg(baseaddr, MY_CUSTOM_IP_REGISTER_INTR_IPISR_OFFSET, IpStatus);
  }

}

