#include "sysace_stdio.h"
#include "xparameters.h"
#include "xutil.h"
#include "xio.h"
#include "stdio.h"
#include "my_custom_ip_register.h"
#include "xintc.h"
#include "mb_interface.h"

#define SLV_REG0		0x00000000
#define SLV_REG1		0x00000004
#define SLV_REG2		0x00000008
#define SLV_REG3		0x0000000C
#define SLV_REG4		0x00000010
#define BaseAddress  0xCCC00000
#define read			0x00000001
#define reset			0x00000000


void intr_handler(){ 
	char*file_out = "outfile.txt";		//declaring the output file name, type and directory
	char readValue;						//variable to store data 
	int numwrite;
	SYSACE_FILE * outfile;				//output file handler
	unsigned char buffer[4]= "test";	//data to be written to the file
		
	
	status = MY_CUSTOM_IP_REGISTER_mReadReg(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR, MY_CUSTOM_IP_REGISTER_INTR_IPISR_OFFSET);   //read the status of the interrupt service register
	MY_CUSTOM_IP_REGISTER_mWriteReg(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR, MY_CUSTOM_IP_REGISTER_INTR_IPISR_OFFSET, 0);   		//Acknowledge interrupt on peripheral
	XIntc_mAckIntr(XPAR_XPS_INTC_0_BASEADDR,XPAR_MY_CUSTOM_IP_REGISTER_0_IP2INTC_IRPT_MASK);									//Acknowledge interrupt on interrupt controller
	
	
	outfile = sysace_fopen(file_out,"w");						//open file in write mode											
	numwrite = sysace_fwrite(buffer,1,sizeof(buffer),outfile);	//write the data in buffer to the file										 
	sysace_fclose(outfile);										//close file
}

void init(){
   // Registering an Interrupt handler
	 XIntc_RegisterHandler(XPAR_XPS_INTC_0_BASEADDR, XPAR_XPS_INTC_0_MY_CUSTOM_IP_REGISTER_0_IP2INTC_IRPT_INTR,
    intr_handler, (void *)XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR);
	
	// enabling interrupts on the interrupt controller, my_custom_ip and microblaze
	 XIntc_mMasterEnable(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR);
	 XIntc_mEnableIntr(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR,
    XPAR_MY_CUSTOM_IP_REGISTER_0_IP2INTC_IRPT_MASK);		 
	 MY_CUSTOM_IP_REGISTER_EnableInterrupt((void *) XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR);
	 microblaze_enable_interrupts();		
				
}


int main(void){
init();				//run the function to set up the interrupts
intr_handler();		//the function run for every interrupt

	while(1){

	}

return 0;
}
