#include "sysace_stdio.h"
#include "xparameters.h"
#include "xutil.h"
#include "xio.h"
#include "stdio.h"
#include "my_custom_ip_register.h"
#include "xintc.h"
#include "mb_interface.h"

void intr_handler(){ 
	
SYSACE_FILE * outfile;
char*	file_out = "outfile.txt";	//output file name, type and directory
Xuint32 readValue;					//variable to store data read from the register	
Xuint32 status;						//status of the interrupt register
char 	test[3];					//variable used to store char representation of readValue
char 	data[30];					//variable that is written to the cf card

		status = MY_CUSTOM_IP_REGISTER_mReadReg(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR, MY_CUSTOM_IP_REGISTER_INTR_IPISR_OFFSET);   //read the status of the interrupt service register
		MY_CUSTOM_IP_REGISTER_mWriteReg(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR, MY_CUSTOM_IP_REGISTER_INTR_IPISR_OFFSET, 0);   		//Acknowledge interrupt on peripheral
		XIntc_mAckIntr(XPAR_XPS_INTC_0_BASEADDR,XPAR_MY_CUSTOM_IP_REGISTER_0_IP2INTC_IRPT_MASK);									//Acknowledge interrupt on interrupt controller

		outfile = sysace_fopen(file_out,"w");																						//open file in write mode
	   readValue = MY_CUSTOM_IP_REGISTER_mReadReg(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR,MY_CUSTOM_IP_REGISTER_SLV_REG3_OFFSET);		//read value from register 3
	   test[0] = readValue;																											//stores value in the test variable
		strncat(data,test,2);																		//stores the test value into a char array
		sysace_fwrite((char *)data,1,sizeof(data),outfile);										//writes the value of data to the cf card
		sysace_fclose(outfile);																		//close the file	
		
		}

int init(i){
	 // Registering an Interrupt handler
	 XIntc_RegisterHandler(XPAR_XPS_INTC_0_BASEADDR, XPAR_XPS_INTC_0_MY_CUSTOM_IP_REGISTER_0_IP2INTC_IRPT_INTR,
    intr_handler, (void *)XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR);
	
	 // enabling interrupts on the interrupt controller, my_custom_ip and microblaze
	 XIntc_mMasterEnable(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR);
	 XIntc_mEnableIntr(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR,
    XPAR_MY_CUSTOM_IP_REGISTER_0_IP2INTC_IRPT_MASK);		 
	 MY_CUSTOM_IP_REGISTER_EnableInterrupt((void *) XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR);
	 microblaze_enable_interrupts();
	i=0;
	return i;
}


int main(void){
MY_CUSTOM_IP_REGISTER_mWriteReg(XPAR_MY_CUSTOM_IP_REGISTER_0_BASEADDR,MY_CUSTOM_IP_REGISTER_SLV_REG3_OFFSET,0xA2); //writing a test value to register 3

init();		//function to set up the interrupts


intr_handler();		//function that is invoked when there is an interrupt.


	while(1){
	}

return 0;
}
